# Function RxapDataSource

- RxapDataSource<Metadata>(dataSourceIdOrMetadata, className?, packageName?): ((target) => void)

- #### Type Parameters

  - Metadata extends BaseDataSourceMetadata

  #### Parameters

  - dataSourceIdOrMetadata: string | Metadata
  - className: string = 'BaseDataSource'
  - packageName: string = '@rxap/data-source'

  #### Returns ((target) => void)

  - - (target): void

    - #### Parameters

      - target: Constructor<BaseDataSource<any, BaseDataSourceMetadata, BaseDataSourceViewer<any>>>

      #### Returns void

  - Defined in packages/angular/data-source/src/lib/base.data-source.ts:331